

{%- import "src/_tree_utils.j2" as tree with context -%}
{%- import "src/_utils.j2" as utils with context -%}
{%- import "src/_monitoring.j2" as monitoring with context -%}
{%- import "src/_rda_template.j2" as rda_dmp_cs with context -%}
{%- import "src/_opidor_template.j2" as opidor_dic with context -%}
{%- import "src/_constraints.j2" as constraints with context -%}
{%- import "src/_contributor_contact.j2" as contributor with context -%}
{%- import "src/_dataset.j2" as dataset with context -%}
{%- import "src/_temp_distribution.j2" as temp_distribution with context -%}
{%- import "src/_distribution.j2" as distribution with context -%}
{%- import "src/_format.j2" as format with context -%}
{%- import "src/_data_sharing.j2" as data_sharing with context -%}
{%- import "src/_elsi.j2" as elsi with context -%}
{%- import "src/_dmp_general.j2" as dmp with context -%}
{%- import "src/_completion.j2" as completion with context -%}


{#- this below describes how the annotation tree construction is implemented

- the data structure to help us along is a stack of nodes to track the current node
- also, we have the tree structure, which is no more than a dictionnary

How will we do this?

- tree is initiated as the node {} which is also set as the current node (push on stack)
- we'll unfold the document context: chapter, questions, but as usual, only those annotated
  questions, with or without replies  {%- do local_ns.child_of.append( { dc.qtn.uuid :
  '00000000-0000-0000-0000-000000000000' } ) -%}

- also recall, there are strictly no rules as to how DSW entities are annotated (or not), except for
  the fact that only annotations whose key = "interop"  are considered

- each question type will be processed differently:

  - ItemList   (renderAnswerList)
    - current node is identified
    - a list [] is created to collect all nodes possibly created by annotated followup questions
    - a current node {} is created for each followup question,
      and pushed and popped appropriately as each followup question is processed in turn
    - once all followup questions have been processed:
      - we have a list of nodes representing the followup questions 
        (from which the empty nodes {} have been removed)
      - if the ItemList question is annotated, we update the current node 
        with { annotation of ItemList question : list of nodes }
      - if the ItemList question is NOT annotated, we update the current node 
        as follows (see transformList2MappingsInLastNode):
        typically the list of nodes looks like 
        [ {annotationA : ...}, {annotationB : ...}, {annotationC : ...}... ]
        more often, it could look like 
        [ {annotationA : X}, {annotationA : Y}, {annotationC : Z}... ]
        therefore we transform this into mappings as such
        {annotationA : [X,Y]}, {annotationC : Z}, ...
        and the current node is updated with 
        {annotationA : [X,Y]}, {annotationC : Z}, ...
    
   - value/integration question (renderAnswerValue)
     - current node is identified
     - if question is annotated, update current node with { annotation : answer }

   - multi-choice question
     - current node is identified
     - a list [] is created to collect 
       i) if the choice is annotated, the node created by {choice annotation : choice value}
       ii) if the choice is not annotated, the string "choice value"
     - if multi-choice question is annotated, we update the current node 
        with { annotation of multi-choice question : list }
     - if multi-choice question is NOT annotated, we proceed with transformList2MappingsInLastNode
       (note that all simple string elements of the list will be ignored, which is correct,
        as the question is not annotated...)

   - option question
     - current node is identified
     - a list [] is created to collect 
       i) if the option is annotated, the node created by {option annotation : option value}
       ii) if the option is not annotated, the string "option value"
       iii) the nodes possibly created by annotated followup questions
         - a current node {} is created for each followup question,
           and pushed and popped appropriately as each followup question is processed in turn
     - once all followup questions have been processed:
       - if option question is annotated, we update the current node 
          with { annotation of multi-choice question : list }
       - if option question is NOT annotated, we proceed with transformList2MappingsInLastNode
         (again, note that all simple string elements of the list will be ignored, which is correct,
          as the question is not annotated...)

- a few comments:
 
  - at this stage, I am not quite certain of how to process paths, maybe not at all?
    - yes, but paths are required to deploy the tree!!!! (of questions and answers)
  - important notes:
    - this algorithm does not prescribe if questions should be annotated
      (for example, one can have an ItemList question non-annotated, but with 
       some followup questions annotations; the same holds for all types of questions
  - finally, note that all keys in the tree dictionnairy are annotations...


- a flag (passed as an argument): process_annotation

  consider the following:
  1. suppose one answers an option question with followup questions with answers as well.
  2. suppose one supresses the answer to the option question,
     so that there is no reply to that question.
  3. the problem is that the answers to the follow up questions
     still show up (they are kept in memory -- this is a bit bizarre, but maybe from
     the perspective of the user filling in the questionnaire, it could be a time saver)

     and the way we traverse the whole tree (to construct the tree of annotations)
     with or without answers ensures that the answers to the follow up questions
     will be processed if annotated... which we do not want when creating the RDA dmp object

     For this purpose we use this flag to tell us not to call processAnnotation
     in those specific cases.

     To sum up,
       we need this flag because there is a conflict between 
        - wanting to go down the tree with or without answers to question for the purpose 
          of constructing the annotation tree 
        - and only processing annotations for interoperability purposes where there are answers 

-#}






{#- ----------------------------------------------------------------------- -#}
{#-  GLOBAL VARIABLES                                                       -#}
{#-  ----------------------------------------------------------------------- -#}
{#- to see the latest document context:                                     -#}
{#-   https://guide.ds-wizard.org/en/latest/_images/document-context.svg    -#}
{#-                                                                         -#}
{#-  the document context giving access to all DSW entities                 -#}

{%- set global_ns = namespace(description="global in main tree") -%}
{%- set dc = ctx|to_context_obj -%}

{#- ----------------------------------------------------------------------- -#}
{#-  end of GLOBAL VARIABLES                                                -#}
{#- ----------------------------------------------------------------------- -#}

{#- ------------------------------------------------------------  -#}
{#- globals to THIS file, which we call locals... -#}
{#- ------------------------------------------------------------  -#}
{#- variables global to this file, not meant to be used by the caller  -#}

{%- set local_ns = namespace(description="local in main tree") -%}
{%- set local_ns.node_stack = [] -%}

{%- set local_ns.root_uuid = '00000000-0000-0000-0000-000000000000' -%}
{%- set local_ns.uuid_stack = [] -%}

{%- set local_ns.exists_annotation = false -%}
{%- set local_ns.annotation = none -%}

{%- macro initTree(globals) -%}
  {%- set new_node = {} -%}
  {%- do globals.global_ns.main_vars.update( { "tree" : new_node }) -%}
  {%- do local_ns.node_stack.append(new_node) -%}
{%- endmacro -%}


{%- macro lookForInteropAnnotation(globals, entity) -%}
  {%- set local_ns.exists_annotation = false -%}
  {%- if entity.annotations -%}
    {%- for key, annotation in entity.annotations.items() -%}
      {#- we need to check which annotations we are interested in -#}
      {#- since different annotations may serve different purposes -#}
      {%- if key == "interop" -%}
        {%- if local_ns.exists_annotation -%}
          {{ warningMessage(false, "in lookForInteropAnnotation, only one annotation is permitted per entity") }}
        {%- endif -%}
        {%- set local_ns.exists_annotation = true -%}
        {%- set local_ns.annotation = annotation -%}
      {%- endif -%}
    {%- endfor -%}
  {%- endif -%}
{%- endmacro -%}

{#- ----------------------------------------------------------------------- -#}
{#-  Annotation MACROS                                                        -#}
{#- ----------------------------------------------------------------------- -#}














{%- macro processAnnotation(globals, entity, annotation, reply, uuid) -%}
  
  {%- set dmp_being_built = globals.global_ns.main_vars.dmp_being_built -%}

  
  {{ monitoring.trackAnnotation(annotation) }}


  {%- if annotation == "Contact" -%}
    {{ contributor.createAndFillContact(dmp_being_built, uuid) }}
  {%- elif annotation == "Contributor" -%}
    {{ contributor.createContributor(globals, dmp_being_built, uuid) }}
  {%- elif annotation == "ContributorId" -%}
    {{ contributor.createContributorId(globals, dmp_being_built, uuid) }}
  {%- elif annotation == "Dataset" -%}
    {{ dataset.createDataset(globals, dmp_being_built, uuid) }}
  {%- elif annotation == "DatasetId" -%}
    {{ dataset.createDatasetDatasetId(globals, dmp_being_built, uuid) }}
  {%- elif annotation == "ContributorName" -%}
    {{ contributor.processContributorName(globals, dmp_being_built, reply, uuid) }}
  {%- elif annotation == "ContributorIdType" -%}
    {{ contributor.processContributorIdType(globals, dmp_being_built, reply, uuid) }}
  {%- elif annotation == "ContributorIdIdentifier" -%}
    {{ contributor.processContributorIdIdentifier(globals, dmp_being_built, reply, uuid) }}
  {%- elif annotation == "ContributorIdROR" -%}
    {{ contributor.createAndFillContributorIdROR(globals, dmp_being_built, reply, uuid) }}
  {%- elif annotation == "ContributorRole" -%}
    {{ contributor.processContributorRole(globals, dmp_being_built, reply, uuid) }}
  {%- elif annotation == "ContributorMbox" -%}
    {{ contributor.processContributorMbox(globals, dmp_being_built, reply, uuid) }}
  {%- elif annotation == "DatasetName" -%}
    {{ dataset.processDatasetName(globals, dmp_being_built, reply) }}
  {%- elif annotation == "DatasetType" -%}
    {{ dataset.processDatasetType(dmp_being_built, reply) }}
  {%- elif annotation == "DatasetDescription" -%}
    {{ dataset.processDatasetDescription(dmp_being_built, reply) }}
  {%- elif annotation == "DatasetIdIdentifier" -%}
    {{ dataset.processDatasetIdIdentifier(globals, dmp_being_built, reply, uuid) }} 
  {%- elif annotation == "DatasetIdType" -%}
    {{ dataset.processDatasetIdType(globals, dmp_being_built, reply, uuid) }}
  {%- elif annotation == "DatasetDistributionFormats" -%}
    {{ format.setDistributionFormatRoot(globals, uuid) }}
  {%- elif annotation == "DistributionFormatPhysicalSiteNames" -%}
    {{ format.setDistributionFormatPhysicalSiteTitles(globals, entity, reply) }}
  {%- elif annotation == "DatasetDistributionFormat" -%}
    {{ format.processDatasetDistributionFormat(globals,
    dmp_being_built, reply, uuid) }}
  {%- elif annotation == "DataELSI" -%}
    {{ elsi.setELSIRoot(globals, uuid) }}
  {%- elif annotation == "DataELSINames" -%}
    {{ elsi.setELSIDatasetNames(globals, entity, reply) }}
  {%- elif annotation == "DatasetPersonalData" -%}
    {{ elsi.processPersonalData(globals, dmp_being_built, reply, uuid) }}
  {%- elif annotation == "DatasetEthicalIssues" -%}
    {{ elsi.processEthicalIssues(globals, dmp_being_built, reply) }}
  {%- elif annotation == "DatasetSensitiveData" -%}
    {{ elsi.processSensitiveData(globals, dmp_being_built, reply, uuid) }}
  {%- elif annotation == "Infrastructure" -%}
    {{ temp_distribution.processInfrastructure(globals, uuid) }} 
  {%- elif annotation == "InfrastructurePhysicalSite" -%}
    {{ temp_distribution.createInfrastructurePhysicalSite(globals, uuid) }} 
  {%- elif annotation == "InfrastructureName" -%}
    {{ temp_distribution.processInfrastructureName(globals, reply, uuid) }} 
  {%- elif annotation == "InfrastructureAcronym" -%}
    {{ temp_distribution.processInfrastructureAcronym(globals, reply, uuid) }} 
  {%- elif annotation == "InfrastructureURL" -%}
    {{ temp_distribution.processInfrastructureURL(globals, reply, uuid) }} 
  {%- elif annotation == "InfrastructurePhysicalSiteName" -%}
    {{ temp_distribution.processInfrastructurePhysicalSiteName(globals, reply, uuid) }} 
  {%- elif annotation == "InfrastructurePhysicalSiteURL" -%}
    {{ temp_distribution.processInfrastructurePhysicalSiteURL(globals, reply, uuid) }} 
  {%- elif annotation == "DataCollectionNames" -%}
    {{ dataset.setDataCollectionDatasetNames(globals, entity, reply) }}
  {%- elif annotation == "Bioimagery" -%}
    {{ dataset.setBioimageryRoot(globals, uuid) }}
  {%- elif annotation == "Cytometry" -%}
    {{ dataset.setCytometryRoot(globals, uuid) }}
  {%- elif annotation == "Proteomics" -%}
    {{ dataset.setProteomicsRoot(globals, uuid) }}
  {%- elif annotation == "Genomics" -%}
    {{ dataset.setGenomicsRoot(globals, uuid) }}
  {%- elif annotation == "Metabolomics" -%}
    {{ dataset.setMetabolomicsRoot(globals, uuid) }}
  {%- elif annotation == "OtherData" -%}
    {{ dataset.setOtherDataRoot(globals, uuid) }}

  {%- elif annotation == "DataProcessing" -%}
    {{ data_sharing.setDataProcessingRoot(globals, uuid) }}
  {%- elif annotation == "DataProcessingNames" -%}
    {{ data_sharing.setDataProcessingNames(globals, entity, reply) }}
  {%- elif annotation == "DataProcessingPhysicalSites" -%}
    {{ data_sharing.setDataProcessingPhysicalSitesRoot(globals, uuid) }}
  {%- elif annotation == "DataProcessingPhysicalSiteNames" -%}
    {{ data_sharing.setDataProcessingPhysicalSiteTitles(globals, entity, reply) }}
  {%- elif annotation == "DataProcessingSharing" -%}
    {{ data_sharing.setDataProcessingSharingRoot(globals, uuid) }}
  {%- elif annotation == "DataProcessingClosedSharing" -%}
    {{ data_sharing.processDataProcessingSharing(globals, "closed", uuid) }}
  {%- elif annotation == "DataProcessingSharedSharing" -%}
    {{ data_sharing.processDataProcessingSharing(globals, "shared", uuid) }}
  {%- elif annotation == "DataProcessingOpenSharing" -%}
    {{ data_sharing.processDataProcessingSharing(globals, "open", uuid) }}

  {%- elif annotation == "DataStorage" -%}
    {{ data_sharing.setDataStorageRoot(globals, uuid) }}
  {%- elif annotation == "DataStorageNames" -%}
    {{ data_sharing.setDataStorageNames(globals, entity, reply) }}
  {%- elif annotation == "DataStoragePhysicalSites" -%}
    {{ data_sharing.setDataStoragePhysicalSitesRoot(globals, uuid) }}
  {%- elif annotation == "DataStoragePhysicalSiteNames" -%}
    {{ data_sharing.setDataStoragePhysicalSiteTitles(globals, uuid) }}
  {%- elif annotation == "DataStorageSharing" -%}
    {{ data_sharing.setDataStorageSharingRoot(globals, uuid) }}
  {%- elif annotation == "DataStorageClosedSharing" -%}
    {{ data_sharing.processDataStorageSharing(globals, "closed", uuid) }}
  {%- elif annotation == "DataStorageSharedSharing" -%}
    {{ data_sharing.processDataStorageSharing(globals, "shared", uuid) }}
  {%- elif annotation == "DataStorageOpenSharing" -%}
    {{ data_sharing.processDataStorageSharing(globals, "open", uuid) }}
  {%- elif annotation == "DMPId" -%}
    {{ dmp.createDMPId(globals, dmp_being_built, uuid) }}
  {%- elif annotation == "DMPIdIdentifier" -%}
    {{ dmp.setDMPIdIdentifier(globals, dmp_being_built, reply, uuid) }}
  {%- elif annotation == "DMPIdType" -%}
    {{ dmp.setDMPIdType(globals, dmp_being_built, reply, uuid) }}

  {%- endif -%}

{%- endmacro -%}


{%- macro updateNode(globals, node, annotation, value) -%}
  
  {%- if annotation not in node -%}
    {%- do node.update( { annotation : value } ) -%}
  {%- else -%}
    {%- set local_ns.need_to_create_list = true -%}
    {%- set existing_value = node[annotation] -%}
    {%- if existing_value is sequence and existing_value is not string -%}
      {%- set local_ns.need_to_create_list = false -%}
    {%- endif -%}

    {%- if local_ns.need_to_create_list  -%}
      {%- set local_ns.list = [] -%}
      {%- do local_ns.list.append(existing_value) -%}
      {%- if value is sequence and value is not string -%}
        {%- for elt in value -%}
          {%- do local_ns.list.append(elt) -%}
        {%- endfor -%}
      {%- else -%}
        {%- do local_ns.list.append(value) -%}
      {%- endif -%}
      {%- do node.update( { annotation : local_ns.list } ) -%}
    {%- else -%}
      {#- in this case, existing_value is necessarily a sequence -#}
      {%- if value is sequence and value is not string -%}
        {%- for elt in value -%}
          {%- do existing_value.append(elt) -%}
        {%- endfor -%}
      {%- else -%}
        {%- do existing_value.append(value) -%}
      {%- endif -%}
    {%- endif -%}
  {%- endif -%}


{%- endmacro-%}


{#- ----------------------------------------------------------------------- -#}
{#-  ANSWERS MACROS                                                         -#}
{#- ----------------------------------------------------------------------- -#}
{%- macro renderAnswerValue(globals, process_annotation, question, reply, path) -%}

  {%- if not reply -%}
    {%- set answer = none -%}
  {%- elif reply is of_type("StringReply") -%}
    {%- set answer = reply.value -%}
  {%- else -%}
    {%- set answer = reply.value|markdown  -%}
    {%- if reply.is_integration -%}
      {%- set integration = question.integration -%}
      {%- set answer = integration.item(reply.item_id) -%}
    {%- endif -%}
  {%- endif -%}

  {{ lookForInteropAnnotation(globals, question) }}
  {%- set exists_annotation = local_ns.exists_annotation -%}
  {%- if exists_annotation -%}
      {%- if reply and process_annotation -%}
        {{ processAnnotation(globals, question, local_ns.annotation, answer, question.uuid) }}
      {%- endif -%}

      {%- set last_node = local_ns.node_stack|last -%}
      {{ updateNode(globals, last_node, local_ns.annotation, answer) }}
  {%- endif -%}

{%- endmacro -%}


{%- macro renderAnswerOption(globals, process_annotation, question, reply, path) -%}
  {%- if reply -%}
    {%- set answer = reply.answer -%}
  {%- else -%}
    {%- set answer = none  -%}
  {%- endif -%}
  
  {{ lookForInteropAnnotation(globals, question) }}
  {%- set exists_annotation = local_ns.exists_annotation -%}
  {%- set local_question_annotation = local_ns.annotation -%}
  {%- set last_question_node = local_ns.node_stack|last -%}

  {%- set local_list = [] -%}
  
  {%- for option in question.answers -%}

    {%- set option_node = {} -%}
    {%- set local_option_list = [] -%}

    {{ lookForInteropAnnotation(globals, option) }}
    {%- set exists_answer_annotation = local_ns.exists_annotation -%}
    {%- set answer_annotation = local_ns.annotation -%}

    {{ tree.updateChildOfRelations(globals, local_ns.uuid_stack|last, option.uuid) }}
    {% do local_ns.uuid_stack.append(option.uuid) %}

    {%- if reply and option.label == answer.label -%}
      
      {#-        {%- if local_question_annotation == "ContributorIdType" -%} -#}
      {#-          {{ "\nanswer.label " ~ answer.label }} -#}
      {#-        {%- endif -%} -#}

      {#- note: it is correct to call processAnnotation within this loop -#}
      {#- as we are interested in this iff there is an answer to the question -#}
      {#- AND we might have a need for answer.label! -#}
      {%- if exists_annotation and process_annotation -%}
        {{ processAnnotation(globals, question, local_question_annotation, answer.label, question.uuid) }}
      {%- endif -%}
      
      {%- if exists_answer_annotation and process_annotation -%}

        {{ processAnnotation(globals, option, answer_annotation, answer.label, option.uuid) }}

        {#- this below cannot happen: -#}
        {#-  {%- elif exists_answer_annotation and not process_annotation -%}-#}
        {#- {%- do local_list.append({ answer_annotation : answer.label }) -%}-#}
        {#- because if not process_annotation then somewhere above in the annotation tree -#}
        {#- there was a question without an answer -#}
        {#- and the way the dsw questionnaire tree is created, it is -#}
        {#- then impossible to have an answer further down, as we are here -#}
        {#- precisely: "if reply" -#}
        
        {%- set option_node = { answer_annotation : answer.label } -%}
      {%- else -%}
        {%- do local_list.append(answer.label) -%}
      {%- endif -%} 
    {%- else -%}
      {%- if exists_answer_annotation -%}
        {%- set option_node = { answer_annotation : none } -%}
      {%- endif -%}

      {#- note: here we need to set process_annotation to false as we are in the case -#}
      {#- of no reply to the current option considered -#}
      {%- set process_annotation = false -%} 
    {%- endif -%}

    {#- track the answer/option's uuid -#}
    {%- set path = path ~ '.' ~ option.uuid -%}

    {%- set new_node = {} -%}
    {%- do local_option_list.append(new_node) -%}
    {%- do local_ns.node_stack.append(new_node) -%}

    {%- for question in option.followups -%}
      {#- because of the control of the value of process_annotation, we control if -#}
      {#- annotations are processed further on -#}
      {#- we have to play this game because there is a conflict between -#}
      {#-  - wanting to go down the tree with or without answers to question for the purpose -#}
      {#-    of constructing the annotation tree -#}
      {#-  - and only processing annotations where there are answers -#}
      {#- (there is an example given of this happening on top of this file) -#}
      {{ renderQuestion(globals, process_annotation, question, path) }}
    {%- endfor -%}

    {#- length counts the number of node attributes -#}
    {#- {{"*** new_node " ~ new_node }}-#}
    {#- {{"*** new_node length " ~ new_node|length ~ " "}}-#}
    {%- if new_node|length == 0 -%} 
      {%- do local_option_list.pop() -%}  
    {%- endif -%}
    {%- do local_ns.node_stack.pop() -%} 

    {%- do local_ns.uuid_stack.pop() -%}

    {%- if exists_answer_annotation -%}
      {{ updateNode(globals, option_node, answer_annotation, local_option_list) }}
    {%- else -%}
      {{ transformList2MappingsInLastNode(option_node, local_option_list) }} 
    {%- endif -%}
    {%- if option_node|length > 0 -%} 
      {%- do local_list.append(option_node) -%}  
    {%- endif -%}
  {%- endfor -%}

  {%- if exists_annotation -%} 
    {{ updateNode(globals, last_question_node, local_question_annotation, local_list) }}
  {%- else -%}
    {{ transformList2MappingsInLastNode(last_question_node, local_list) }} 
  {%- endif -%} 
{%- endmacro -%}



{%- macro renderChoiceList(globals, process_annotation, question, reply, path) -%}

  {{ lookForInteropAnnotation(globals, question) }}
  {%- set exists_annotation = local_ns.exists_annotation -%}
  {%- set local_question_annotation = local_ns.annotation -%}
  {%- set last_node = local_ns.node_stack|last -%}
  {%- set local_list = [] -%}

  {%- for choice in question.choices -%}

{#-    {%- if local_question_annotation == "DatasetDistributionFormat" -%} -#}
{#-      {{ " choice " ~ choice.label ~ " local_list before choices " ~ local_list }}-#}
{#-    {%- endif -%}-#}

    {{ lookForInteropAnnotation(globals, choice) }}
    {%- set exists_choice_annotation = local_ns.exists_annotation -%}
    {%- set choice_annotation = local_ns.annotation -%}
    {%- if choice in reply.choices -%}
      {#- note: it is correct to call processAnnotation within this loop -#}
      {#- as we are interest in this iff there is an answer to the question -#}
      {#- AND we might have a need for choice.label! -#}
      {#- -#}
      {#- BUT in this specific case, if choice.label is not relevant, -#}
      {#- we must make sure there is only one call to whatever is relevant -#}
      {#- in processAnnotation and further down in the call stack -#}
      {#- how to do it? not sure yet -#}
      {%- if exists_annotation and process_annotation -%}
        {{ processAnnotation(globals, question, local_question_annotation, choice.label, question.uuid) }}
      {%- endif -%}

      {{ tree.updateChildOfRelations(globals, local_ns.uuid_stack|last, choice.uuid) }}
      {% do local_ns.uuid_stack.append(choice.uuid) %}


      {%- if exists_choice_annotation and process_annotation -%}
        {{ processAnnotation(globals, choice, choice_annotation, choice.label, choice.uuid) }}

        {%- do local_list.append({ choice_annotation : choice.label }) -%}
      {%- else -%}
        {%- do local_list.append(choice.label) -%}
      {%- endif -%}

      {%- do local_ns.uuid_stack.pop() -%}
    {%- else -%}
      {%- if exists_choice_annotation -%}
        {%- do local_list.append({ choice_annotation : none }) -%}
      {%- endif -%}
    {%- endif -%}

{#-     {%- if local_question_annotation == "DatasetDistributionFormat" -%}-#}
 {#-      {{ " choice " ~ choice.label ~ " local_list after choices " ~ local_list }}-#}
{#-     {%- endif -%}-#}
  {%- endfor -%}

{#-   {%- if local_question_annotation == "DatasetDistributionFormat" -%}-#}
{#-     {{ " DatasetDistributionFormat before last process " ~ local_list }}-#}
 {#-  {%- endif -%}-#}

  {%- if exists_annotation -%}
    {{ updateNode(globals, last_node, local_question_annotation, local_list) }}
  {%- else -%}
    {{ transformList2MappingsInLastNode(last_node, local_list) }} 
  {%- endif -%} 

{#-   {%- if local_question_annotation == "DatasetDistributionFormat" -%}-#}
{#-     {{ " DatasetDistributionFormat after last process " ~ local_list }}-#}
{#-   {%- endif -%}-#}

{%- endmacro -%}

{%- macro transformList2MappingsInLastNode(last_node, list) -%}

{#-   {{ "TRANSFORM before, last_node " ~ last_node }}-#}
{#-     {{ "TRANSFORM before, list " ~ list }}-#}

  {%- set temp_node = {} -%}
  {%- for elt in list -%} 
    {%- if elt is mapping -%}
      {%- for key, value in elt.items() -%}
        {%- if key in temp_node -%}
          {%- set key_value = temp_node[key]  -%}
          {%- if value is sequence and value is not string -%}
            {#- we don't want things like [[ or [[[... ! -#}
            {%- for e in value  -%}
              {%- if e -%}
                {%- do key_value.append(e) -%} 
              {%- endif -%}
            {%- endfor -%}
          {%- elif value -%}
            {%- do key_value.append(value) -%} 
          {%- endif -%}
        {%- else -%}
          {%- set node_list = [] -%}
          {%- do temp_node.update({ key : node_list }) -%}
          {%- if value is sequence and value is not string  -%}
            {%- for e in value  -%}
              {%- if e -%}
                {%- do node_list.append(e) -%} 
              {%- endif -%}
            {%- endfor -%}
          {%- elif value -%}
            {%- do node_list.append(value) -%} 
          {%- endif -%}
        {%- endif -%}
      {%- endfor -%}
    {%- endif -%}
  {%- endfor -%}

{#-   {{ "\nTRANSFORM after, temp_node " ~ temp_node }} -#}

  {%- for key, value in temp_node.items() -%}
    {{   updateNode(none, last_node, key, value)  }}
  {%- endfor -%}

{%- endmacro -%}

{%- macro renderAnswerList(globals, process_annotation, question, reply, path) -%}

  {{ lookForInteropAnnotation(globals, question) }}
  {%- set exists_annotation = local_ns.exists_annotation -%}
  {%- set local_question_annotation = local_ns.annotation -%}
  {%- set last_node = local_ns.node_stack|last -%}

  {%- set local_list = [] -%}

  {%- set itemPathPrefix = path ~ '.' -%}
  {%- if not reply -%}
    {%- set new_node = {} -%}
    {%- do local_list.append(new_node) -%}
    {%- do local_ns.node_stack.append(new_node) -%}

    {%- set process_annotation = false -%}
    {%- for question in question.followups -%}           
      {{ renderQuestion(globals, process_annotation, question, path) }}        
    {%- endfor -%}

    {%- if new_node|length == 0 -%}
      {%- do local_list.pop() -%} 
    {%- endif -%}
    
    {%- do local_ns.node_stack.pop() -%} 
  {%- else -%} {#- there is a reply -#}

    {{ monitoring.trackItemListStart() }} 
    {%- for item in reply.items -%}

      {%- set itemPath = itemPathPrefix ~ item -%}

      {{ tree.updateChildOfRelations(globals, local_ns.uuid_stack|last, item) }} 
      {% do local_ns.uuid_stack.append(item) %}

      {%- if exists_annotation and process_annotation -%} 
        {{ processAnnotation(globals, question, local_question_annotation, none, item) }}
      {%- endif -%} 

      {#- one node per item -#}
      {%- set new_node = {} -%}
      {%- do local_list.append(new_node) -%}
      {%- do local_ns.node_stack.append(new_node) -%}
      
      {%- for question in question.followups -%}
        {{ renderQuestion(globals, process_annotation, question, itemPath) }}        
      {%- endfor -%}

      {#- length counts the number of node attributes -#}
      {#- {{"*** new_node " ~ new_node }}-#}
      {#- {{"*** new_node length " ~ new_node|length ~ " "}}-#}
      {%- if new_node|length == 0 -%}
        {%- do local_list.pop() -%} 
      {%- endif -%}

      {%- do local_ns.node_stack.pop() -%} 
      {%- do local_ns.uuid_stack.pop() -%}

    {%- endfor -%}
  {%- endif -%} 

  {%- if exists_annotation -%}
    {{ updateNode(globals, last_node, local_question_annotation, local_list) }}
  {%- else -%}
    {{ transformList2MappingsInLastNode(last_node, local_list) }}
  {%- endif -%} 

  {%- if reply -%}
    {{ monitoring.processItemListEnd(globals) }}
  {%- endif -%}

{%- endmacro -%}



{#- ----------------------------------------------------------------------- -#}
{#-  QUESTION MACROS                                                        -#}
{#- ----------------------------------------------------------------------- -#}
{%- macro renderQuestionReply(globals, process_annotation, question, path) -%}    
  {%- set reply = question.replies.get(path) -%}    
  {%- if reply and reply.value -%}
    {#- process all questions as long as they have answers -#}

    {%- if question is of_type('ValueQuestion') and reply is of_type('StringReply') -%}
      {{ renderAnswerValue(globals, process_annotation, question, reply, path) }}        
    {%- elif question is of_type('OptionsQuestion') and reply is of_type('AnswerReply') -%}
      {{ renderAnswerOption(globals, process_annotation, question, reply, path) }}        
    {%- elif question is of_type('ListQuestion') and reply is of_type('ItemListReply') -%}
      {{ renderAnswerList(globals, process_annotation, question, reply, path) }}        
    {%- elif question is of_type('IntegrationQuestion') and reply is of_type('IntegrationReply') -%}
      {{ renderAnswerValue(globals, process_annotation, question, reply, path) }}       
     {%- elif question is of_type('MultiChoiceQuestion') and reply is of_type('MultiChoiceReply') -%}
      {{ renderChoiceList(globals, process_annotation, question, reply, path) }}
    {%- endif -%}
  {%- else -%}
    {%- if question is of_type('ValueQuestion') -%}
      {{ renderAnswerValue(globals, process_annotation, question, none, path) }}        
    {%- elif question is of_type('OptionsQuestion') -%}
      {{ renderAnswerOption(globals, process_annotation, question, none, path) }}        
    {%- elif question is of_type('ListQuestion') -%}
      {{ renderAnswerList(globals, process_annotation, question, none, path) }}        
    {%- elif question is of_type('IntegrationQuestion') -%}
      {{ renderAnswerValue(globals, process_annotation, question, none, path) }}       
     {%- elif question is of_type('MultiChoiceQuestion') -%}
      {{ renderChoiceList(globals, process_annotation, question, none, path) }}
    {%- endif -%}
{%- endif -%}

{%- endmacro -%}

{%- macro renderQuestion(globals, process_annotation, question, path) -%}

  {{ tree.updateChildOfRelations(globals, local_ns.uuid_stack|last, question.uuid) }}
  {% do local_ns.uuid_stack.append(question.uuid) %}


  {%- set path = path ~ '.' ~ question.uuid -%}    
  {{ renderQuestionReply(globals, process_annotation, question, path) }}

  {%- do local_ns.uuid_stack.pop() -%}
{%- endmacro -%}



{#- ----------------------------------------------------------------------- -#}
{#-  CHAPTER MACROS                                                         -#}
{#- ----------------------------------------------------------------------- -#}
{%- macro renderChapter(globals, chapter) -%}
  {#- note: here we ignore the possible chapter's annotations... -#}
  {#- should we take care of them?  -#}

  {{ tree.updateChildOfRelations(globals, local_ns.uuid_stack|last, chapter.uuid) }} 
  {% do local_ns.uuid_stack.append(chapter.uuid) %}

  {%- set process_annotation = true -%}
  {#- as to the meaning of this flag, see the comment on the top of this file -#}
  {%- for question in chapter.questions -%}
    {{ renderQuestion(globals, process_annotation, question, chapter.uuid) }}
  {%- endfor -%}

  {%- do local_ns.uuid_stack.pop() -%}
{%- endmacro -%}

{#- ----------------------------------------------------------------------- -#}
{%- macro render(globals) -%}

  {%- do local_ns.uuid_stack.append(local_ns.root_uuid) -%}

  {{ tree.updateChildOfRelations(globals, local_ns.uuid_stack|last, dc.qtn.uuid) }} 
  {% do local_ns.uuid_stack.append(dc.qtn.uuid) %}

  {%- for chapter in dc.km.chapters -%}
    {{ renderChapter(globals, chapter) }}
  {%- endfor -%}
  
  {%- do local_ns.uuid_stack.pop() -%}
{%- endmacro -%}

{#- ----------------------------------------------------------------------- -#}

{%- macro createObjects(globals) -%}

  {%- if globals.global_ns.main_vars.rda_mapping -%}
    {{ utils.deepCopy(rda_dmp_cs.dmp_skeleton) }}
  {%- elif globals.global_ns.main_vars.opidor_mapping -%}
    {{ utils.deepCopy(opidor_dic.dmp_skeleton) }}
  {%- endif -%}
  {%- do globals.global_ns.main_vars.update( { "dmp_being_built" : utils.global_ns.var_stack.pop() } ) -%}
 
  {{ initTree(globals) }}
  {{ render(globals) }}
  {{ completion.completePopulatingDMPJSONObject(dc, globals, globals.global_ns.main_vars.dmp_being_built) }}
{%- endmacro -%}



